{ nixpkgs, vs-overlay, supportedSystems, allowUnfree ? true }:
let
  lib = import "${nixpkgs}/lib";

  forAllSystems = lib.genAttrs supportedSystems;
in
forAllSystems (system:
  let
    pkgs = import nixpkgs {
      inherit system;
      overlays = [ (import vs-overlay) ];
      config = {
        inherit allowUnfree;
      };
    };

    allPackages = pkgs.lib.filterAttrsRecursive
      (k: v: k != "recurseForDerivations")
      {
        inherit (pkgs)
          getnative
          vapoursynthPlugins;
      };

    allPlugins = pkgs.lib.attrValues allPackages.vapoursynthPlugins;
  in
  allPackages // {
    vapoursynthWithPlugins = pkgs.vapoursynth.withPlugins allPlugins;
    vseditWithPlugins = pkgs.vapoursynth-editor.withPlugins allPlugins;
  })
